
(defparameter *okienko-obr* nil)
(defparameter *okienko-text* nil)
(defparameter *x-bord* 10)
(defparameter *y-bord* 10)
(defparameter *cell* 12)


(defun delay (&optional (j 1))
   (dotimes (i (* j 100000))))

(defun draw-s-line (stream x-min y-min x-max y-max &optional (increment 2))
   (if (equal x-min x-max)
      (let ((i y-min))
         (print 'ahoj)
         (while (not (> i y-max))
           (draw-line stream (make-position x-min i) 
             (make-position x-min (+ i 1)))
           (incf i increment)
           )
         )
      (let ((i x-min))
         (while (not (> i x-max))
           (draw-line stream (make-position i y-min) 
             (make-position (+ i 1) y-min))
           (incf i increment)
           )
         )
      )
  )

(defun draw-square (stream x-min y-min x-max y-max &optional (increment 1))
   (let ((i x-min))
      (while (not (> i x-max))
        (draw-line  stream (make-position i y-min) (make-position i y-max))
        (incf i increment))
      )
   )

(defun draw-ant (stream x-min y-min x-max y-max course)
   (cond
         ((equal course 0)
          (draw-square stream (+ x-min 4) (+ y-min 6) (- x-max 4) (- y-max 2))
          (draw-line  stream (make-position (+ x-min 4) (- y-max 4)) 
            (make-position (+ x-min 4) (+ y-min 2)))
          (draw-line  stream (make-position (- x-max 4) (- y-max 4)) 
            (make-position (- x-max 4) (+ y-min 2)))
          )
         ((equal course 1)
          (draw-square stream (+ x-min 2) (+ y-min 4) (- x-max 6) (- y-max 4))
          (draw-line  stream (make-position (+ x-min 2) (+ y-min 4)) 
            (make-position (- x-max 2) (+ y-min 4)))
          (draw-line  stream (make-position (+ x-min 2) (- y-max 4)) 
            (make-position (- x-max 2) (- y-max 4)))
          )
         ((equal course 2)
          (draw-square stream (+ x-min 4) (+ y-min 2) (- x-max 4) (- y-max 6))
          (draw-line  stream (make-position (+ x-min 4) (- y-max 2)) 
            (make-position (+ x-min 4) (+ y-min 4)))
          (draw-line  stream (make-position (- x-max 4) (- y-max 2)) 
            (make-position (- x-max 4) (+ y-min 4)))
          )
         ((equal course 3)
          (draw-square stream (+ x-min 6) (+ y-min 4) (- x-max 2) (- y-max 4))
          (draw-line  stream (make-position (+ x-min 2) (+ y-min 4)) 
            (make-position (- x-max 2) (+ y-min 4)))
          (draw-line  stream (make-position (+ x-min 2) (- y-max 4)) 
            (make-position (- x-max 1) (- y-max 4)))
          )
         )  
   )
   
(defmethod draw-grid ((tr trail) stream)
   (let* (          
          (x-size-win (* *cell* (x-size tr)))
          (y-size-win (* *cell* (y-size tr)))
          (x-max (+ *x-bord* x-size-win))
          (y-max (+ *y-bord* y-size-win))
         )
      (clear-page stream)

      (draw-line stream (make-position  *x-bord* *y-bord*) (make-position *x-bord* y-max))
      (draw-line stream (make-position  *x-bord* *y-bord*) (make-position x-max *y-bord*))
      (draw-line stream (make-position  x-max *y-bord*) (make-position x-max y-max))
      (draw-line stream (make-position  *x-bord* y-max) (make-position x-max y-max))

      (draw-line stream (make-position  (- *x-bord* 2) (- *y-bord* 2)) 
        (make-position (- *x-bord* 2) (+ y-max 2)))
      (draw-line stream (make-position  (- *x-bord* 2) (- *y-bord* 2)) 
        (make-position (+ x-max 2) (- *y-bord* 2)))
      (draw-line stream (make-position  (+ x-max 2) (- *y-bord* 2)) 
        (make-position (+ x-max 2) (+ y-max 2)))
      (draw-line stream (make-position  (- *x-bord* 2) (+ y-max 2)) 
        (make-position (+ x-max 2) (+ y-max 2)))
      
      (dotimes (i (x-size tr))
         (draw-line stream (make-position (+ *x-bord* (* i *cell*)) *y-bord*)
           (make-position (+ *x-bord* (* i *cell*)) y-max))
         )
      (dotimes (i (x-size tr))
         (draw-line stream (make-position *x-bord* (+ *y-bord* (* i *cell*)))
           (make-position x-max (+ *y-bord* (* i *cell*))))
         )
      (dotimes (i (x-size tr))
         (dotimes (j (y-size tr))
            (when (equal (aref (space tr) i j) 1)
               (draw-square stream (+ (* i *cell*) *x-bord*) (+ (* j *cell*) *y-bord*) 
                 (+ (* (+ i 1) *cell*) *x-bord*) (+ (* (+ j 1) *cell*) *y-bord*))
               )
            )
         )
      (draw-ant stream 
        (+ (* (x-position-of-ant tr) *cell*) *x-bord*)
        (+ (* (y-position-of-ant tr) *cell*) *y-bord*) 
        (+ (* (+ (x-position-of-ant tr) 1) *cell*) *x-bord*)
        (+ (* (+ (y-position-of-ant tr) 1) *cell*) *y-bord*)
        (course-of-ant tr))
      (delay)
      )
   )

(defmethod draw-trail ((tr trail))
   (let* ((x-min 300)
          (y-min 50)
          (x-size-win (* *cell* (x-size tr)))
          (y-size-win (* *cell* (y-size tr))))
      (setq *okienko-obr* (open-stream 'bitmap-window *screen*
                        :io 
                        :title (name tr)
                        :window-interior (make-box x-min y-min (+ x-min x-size-win 20) 
                                           (+ y-min y-size-win 20))
                        :user-scrollable nil 
                        ))
      (draw-grid tr *okienko-obr*)
      )
   )

