;triedy :

(defclass individual ()
    ((chromo
      :initform nil
      :initarg :chromo
      :accessor chromo)
     (max-depth
      :initform (max-in-depth *param*)
      :initarg :max-depth
      :accessor max-depth)
     (raw-fitness
      :initform 0.0
      :initarg :raw-fitness
      :accessor raw-fitness)    
     (adjusted-fitness
      :initform 0.0
      :initarg :adjusted-fitness
      :accessor adjusted-fitness)    
     (norm-fitness
      :initform 0.0
      :initarg :norm-fitness
      :accessor norm-fitness)    
     (fn-computed
      :initform 0
      :initarg :fn-computed
      :accessor fn-computed)
     ))

;metody :

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; metoda vrati kopiu jedinca

(defmethod copy-individual ((ind individual))
   (let ((new-ind (make-instance 'individual
                    :chromo (copy-tree (chromo ind))
                    :max-depth (max-depth ind)
                    :raw-fitness (raw-fitness ind)
                    :adjusted-fitness (adjusted-fitness ind)
                    :norm-fitness (norm-fitness ind)
                    :fn-computed (fn-computed ind))))
      new-ind
      )
   )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; funkcie vratia jedinca vytvoreneho metodou full

(defun full-create-tree (max-depth &optional (depth 0))
   (cond
         ((equal depth max-depth) 
          (name (nth (random (length (term-set *param*))) (term-set *param*))))
         (T
           (let ((temp (nth (random (length (func-set *param*))) (func-set *param*))))
              (cons (name temp) 
                (mapcar #'(lambda (a) (full-create-tree max-depth (+ depth 1)))
                  (make-list (num-of-args temp))))
              ))
         )
   )

(defun full-create-individual (depth)
   (let ((new-ind (make-instance 'individual
                    :max-depth depth))
         (tree nil))
      (setf (chromo new-ind) (copy-tree (full-create-tree (max-depth new-ind))))
      new-ind
      )
   )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; funkcie vratia jedinca vytvoreneho metodou grow

(defun grow-create-tree (max-depth &optional (depth 0))
   (cond
         ((equal depth max-depth) 
          (name (nth (random (length (term-set *param*))) (term-set *param*))))
         (T
           (let* ((numb (random (+ (length (term-set *param*)) (length (func-set *param*)))))
                 (temp (nth  numb (append (func-set *param*) (term-set *param*)))))
              (if (< numb (length (func-set *param*)))
                 (cons (name temp) 
                   (mapcar #'(lambda (a) (grow-create-tree max-depth (+ depth 1)))
                     (make-list (num-of-args temp))))
                 (name temp)
                 )
              ))
         )
   )

(defun grow-create-individual (depth)
   (let ((new-ind (make-instance 'individual))
         (tree nil))
      (setf (chromo new-ind) (copy-tree (grow-create-tree depth)))
      (setf (max-depth new-ind) (max-depth-tree (chromo new-ind)))
      new-ind
      )
   )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;

(defun subst-if-food-ahead (tree)
   (cond 
         ((endp tree) tree)
         ((equal (first tree) 'if-food-ahead) (append (list 'if '*food-directly-in-front-of-ant-p*)
                                                (mapcar #'(lambda (tree) (subst-if-food-ahead tree))
                                                  (rest tree))))
         (T (cons (first tree)
              (mapcar #'(lambda (tree) (subst-if-food-ahead tree))
                (rest tree))))
         )
   )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;

(defun subst-tree (beg-tree)
   (let ((tree (copy-tree beg-tree)))
      (when (equal (first tree) 'progn3)                      
         (cond                        
               ((and (equal '(left) (second tree))
                     (equal (second tree) (third tree))
                     (equal (second tree) (fourth tree)))
                (setf tree '(right))
                )
               ((and (equal '(right) (second tree))
                      (equal (second tree) (third tree))
                     (equal (second tree) (fourth tree)))
                (setf tree '(left))
                )
               ((and (equal (second tree) '(left))
                     (equal (third tree) '(right)))
                (setf tree (fourth tree))
                )
               ((and (equal (second tree) '(right))
                     (equal (third tree) '(left)))
                (setf tree (fourth tree))
                )
               ((and (equal (third tree) '(left))
                     (equal (fourth tree) '(right)))
                (setf tree (second tree))
                )
               ((and (equal (third tree) '(right))
                     (equal (fourth tree) '(left)))
                (setf tree (second tree))
                )
               ((equal (second tree) '(nop))
                (setf tree (list 'progn2 (third tree) (fourth tree)))
                )
               ((equal (third tree) '(nop))
                (setf tree (list 'progn2 (second tree) (fourth tree)))
                )
                ((equal (fourth tree) '(nop))
                 (setf tree (list 'progn2 (second tree) (third tree)))
                 )
               )
         )
      (when (equal (first tree) 'progn2)
         (cond
               ((or (equal (second tree) '(nop))
                    (equal (third tree) '(nop)))
                (if (equal (second tree) '(nop))
                   (setf tree (third tree))
                   (setf tree (second tree)))
                )
               ((and (equal (second tree) '(left))
                     (equal (third tree) '(right)))
                (setf tree '(nop))
                )
               ((and (equal (second tree) '(right))
                     (equal (third tree) '(left)))
                (setf tree '(nop))
                )
               )
         )
      (when (equal (first tree) 'if-food-ahead)
         (when (equal (second tree) (third tree))
            (setf tree (second tree))
            )
         )
      tree
      )
   )

   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;

(defun edit-tree (tree)
   (cond
         ((null (rest tree))
          tree
          )
         (T
           (let ((temp (mapcar #'(lambda (subtree) (edit-tree subtree)) (rest tree))))
              (setf temp (cons (first tree) temp))
              (subst-tree temp)
              )
           )
         )
   )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; funkcia odstrani niektore nadbytocne casti (chromo ind)
;; vrati opraveneho jedinca

(defmethod edit-individual ((ind individual))
   (let ((temp (copy-tree (chromo ind)))
         (new-ind (copy-individual ind)))
      (setf (chromo new-ind) (copy-tree (edit-tree temp)))
      (setf (max-depth new-ind) (max-depth-tree (chromo new-ind)))
      (when (equal (chromo new-ind) '(nop))
         (setf new-ind (grow-create-individual (max-in-depth *param*))))
      new-ind
      )
   )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; funkcia vrati adjusted fitness jedinca
;; zaplni sloty raw-fitness adjusted-fitness

(defmethod evaluate ((ind individual))
   (when (equal (fn-computed ind) 0)
      (let ((temp (copy-tree (chromo ind)))
            (res 0))
         (dotimes (i (length (fitness-cases *param*)))
            (setf *trail* (copy-tr (nth i (fitness-cases *param*))))
            (setf *count* 0)
            (setf *eaten-food* 0)
;            (aim-sensors)
;            (describe *trail*)
            (when (equal *graphic* 1) (draw-trail *trail*))
            (setf temp (copy-tree (chromo ind)))
            (setf temp (subst-if-food-ahead temp))
            (while (< *count* (num-of-op *trail*))
              (eval temp)
              )
            (setf res (incf res (- (num-of-food *trail*) *eaten-food*)))
            ) 
         (setf (adjusted-fitness ind) (/ 1 (+ 1 res)))
         (setf (raw-fitness ind) *eaten-food*)
         )
      (setf (fn-computed ind) 1))
   (adjusted-fitness ind)
   )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; funkcie vykona crossover dvoch jedincov a vrati ich potomkov

(defmethod crossover-ind ((par1 individual) (par2 individual))
   (let ((offspring1 nil)
         (offspring2 nil)
         (temp1 0)
         (temp2 0))
      (setf temp1 (get-types (chromo par1)))
      (setf temp2 (get-types (chromo par2)))
      (if (< (random 1.0) (prob-of-chosse-intermediate-node *param*))
         (if (null (second temp1))
            (setf temp1 (third temp1)) 
            (setf temp1 (second temp1))) 
         (setf temp1 (third temp1)) 
         )
      (if (< (random 1.0) (prob-of-chosse-intermediate-node *param*))
         (if (null (second temp2))
            (setf temp2 (third temp2)) 
            (setf temp2 (second temp2))) 
         (setf temp2 (third temp2)) 
         )
      (setf temp1 (nth (random (length temp1)) temp1))
      (setf temp2 (nth (random (length temp2)) temp2))      
      (setf temp1 (swap-subtree (chromo par1) temp1 (chromo par2) temp2))
      (setf temp2 (copy-tree (second temp1)))
      (setf temp1 (copy-tree (first temp1)))
      (if (> (max-depth-tree temp1) (max-creat-depth *param*))
         (setf offspring1 (copy-individual par1))
         (setf offspring1 (make-instance 'individual
                            :chromo temp1
                            :max-depth (max-depth-tree temp1)))
         )
      (if (> (max-depth-tree temp2) (max-creat-depth *param*))
         (setf offspring2 (copy-individual par2))
         (setf offspring2 (make-instance 'individual
                            :chromo temp2
                            :max-depth (max-depth-tree temp2)))
         )
      (list offspring1 offspring2)
      )
   )