
; funkcia vrati zoznam obsahujuci tri prvky : 
; (+ 1 (length tree))
; zoznam indexov medzilahlych uzlov
; zoznam indexov listovych uzlov

(defun get-types (tree &optional (res (list 0 '() '())))
   (cond 
         ((equal (length tree) 1) 
          (setf (third res) (cons (first res) (third res)))
          (incf (first res))
          res
          )
         (T 
            (setf (second res) (cons (first res) (second res)))
            (incf (first res))
            (dolist (subtree (rest tree) res)
               (setf res (get-types subtree res)))
            )
         )
   )

; funkcia vrati pocet uzlov stromu 

(defun num-of-points (tree &optional (numb 0))
   (cond 
         ((endp tree) 
          (if (not (null tree)) (incf numb) numb))
         (T 
           (num-of-points (rest tree) (num-of-points (first tree) numb)))
         )
   )

;funkcia vrati numb-ty uzol stromu (preorder zacinajuci od 0)
 
(defun get-node (tree numb)
   (cond
         ((< (num-of-points tree) numb) nil)
         ((equal numb 0) (if (endp (first tree)) 
                            (first tree)
                            (get-node (first tree) numb)))
         ((endp (first tree)) (get-node (rest tree) (decf numb)))
         (T
           (let ((a (num-of-points (first tree))))
              (if (not (> a numb)) 
                 (get-node (rest tree) (- numb a))
                 (get-node (first tree) numb)))
           )
         )
   )


; funkcia vrati podstrom stromu tree, korenom ktoreho je numb-ty
; uzol stromu tree (preorder zacinajuci 0)

(defun get-subtree (tree numb)
   (cond ((equal numb 0) tree)
         (T (get-subtree1 tree numb))
         )
   )

(defun get-subtree1 (tree numb)
   (cond
         ((< (num-of-points tree) numb) nil)
         ((equal numb 0) (first tree))
         
         ((endp (first tree)) (get-subtree1 (rest tree) (decf numb)))
         (T
           (let ((a (num-of-points (first tree))))
           (if (not (> a numb))
              (get-subtree1 (rest tree) (- numb a))
              (get-subtree1 (first tree) numb)))
           )
         )
   )


; funkcia vrati zoznam, hlavou ktoreho je podstrom stromu tree. Jeho korenom 
; je numb-ty uzol stromu tree (preorder zacinajuci 0). Zvyskom zoznamu je 
; povodny strom tree, v ktorom vybrany podstrom je nahradeny symbolom nil

(defun rem-subtree (tree numb)
   (cond ((equal numb 0) (list nil tree))
         (T (rem-subtree1 tree numb))
         )
   )

(defun rem-subtree1 (tree numb)
   (cond
         ((< (num-of-points tree) numb) nil)
         ((equal numb 0) 
          (list (first tree) (cons nil (rest tree))))
         
         ((endp (first tree)) 
          (let ((res (rem-subtree1 (rest tree) (decf numb))))
             (list (first res) (cons (first tree) (second res)))
             )
          )
         (T
           (let ((a (num-of-points (first tree))))
              (if (not (> a numb))
                 (let ((res (rem-subtree1 (rest tree) (- numb a))))
                    (list (first res) (cons (first tree) (second res)))
                    )
                 (let ((res (rem-subtree1 (first tree) numb)))
                    (list (first res) (cons (second res) (rest tree)))
                    )
                 )
              )
           )
         )
   )

; funkcia vrati zoznam, hlavou ktoreho je podstrom stromu tree nahradeny 
; podstromom subtree . Korenom nahradeneho podstromu je numb-ty uzol stromu 
; tree(preorder zacinajuci 0). Zvyskom zoznamu je strom tree s nahradenym 
; podstromom.

(defun add-subtree (tree numb subtree)
   (cond ((equal numb 0) (list tree subtree))
         (T (add-subtree1 tree numb subtree))
         )
   )

(defun add-subtree1 (tree numb subtree)
   (cond
         ( (not (> (num-of-points tree) numb)) nil)
         ((equal numb 0) 
          (list (first tree) (cons subtree (rest tree))))
         
         ((endp (first tree)) 
          (let ((res (add-subtree1 (rest tree) (decf numb) subtree)))
             (list (first res) (cons (first tree) (second res)))
             )
          )
         (T
           (let ((a (num-of-points (first tree))))
              (if (not (> a numb))
                 (let ((res (add-subtree1 (rest tree) (- numb a) subtree)))
                    (list (first res) (cons (first tree) (second res)))
                    )
                 (let ((res (add-subtree1 (first tree) numb subtree)))
                    (list (first res) (cons (second res) (rest tree)))
                    )
                 )
              )
           )
         )
   )

; funkcia vrati zoznam skladajuci sa z dvoch prvkov : 
; su nimi stromy tree1 a tree2 s vymenenymi podstromami,
; ktorych korenmi su uzly oznacene numb1 (tree1) a numb2 
; (tree2) (preorder zacinajuci 0)

(defun swap-subtree (tree1 numb1 tree2 numb2)
   (cond 
         ((and (not (> numb1 (num-of-points tree1)))
               (not (> numb2 (num-of-points tree2))))
          (let ((tree1-new (copy-tree tree1))
                (tree2-new (copy-tree tree2))
                (res nil))
             
             (setf res (get-subtree tree1-new numb1))
             (setf res (add-subtree tree2-new numb2 res))
             (setf tree2-new (copy-tree (second res)))
             (setf tree1-new (copy-tree (second (add-subtree tree1-new numb1 (first res)))))
             (list tree1-new tree2-new)
             )
          )
         
         (T nil)
         )
   )

