; funkcia vrati T ak je item prvkon zoznamu list
; nil ak nie

(defun mem-of-list (item list)
   (cond
         ((null list) nil)
         ((equal item (first list)) T)
         (T (mem-of-list item (rest list)))
         )
   )

; funkcia vrati maximalnu hlbku stromu tree

(defun max-depth-tree (tree &optional (max-depth 0))
   (cond
         ((equal (length tree) 1) max-depth)
         (T (apply #'max 
              (mapcar #'(lambda (subtree) (max-depth-tree subtree (+ max-depth 1))) 
                           (rest tree))))
         )
   )


(defclass node ()
    (
     (name 
      :initform nil
      :initarg :name
      :accessor name)
     ))

(defclass func-node (node)
    ((num-of-args 
        :initform 0
        :initarg :num-of-args
        :accessor num-of-args)
     ))

(defclass term-node (node)
    (
     ))

(defclass trail ()
    (
     (name
        :initform nil
        :initarg :name
        :accessor name)     
     (x-size 
        :initform 0
        :initarg :x-size
        :accessor x-size)
     (y-size 
        :initform 0
        :initarg :y-size
        :accessor y-size)
     (space 
        :initform nil
        :initarg :space
        :accessor space)
     (x-position-of-ant
        :initform 0
        :initarg :x-position-of-ant
        :accessor x-position-of-ant)
     (y-position-of-ant
        :initform 0
        :initarg :y-position-of-ant
        :accessor y-position-of-ant)     
     (course-of-ant
        :initform 0
        :initarg :course-of-ant
        :accessor course-of-ant)
     (num-of-op 
        :initform 0
        :initarg :num-of-op
        :accessor num-of-op)
     (num-of-food
        :initform 0
        :initarg :num-of-food
        :accessor num-of-food)
     )
   )

(defmethod copy-tr ((tr trail))
   (let ((new-tr (make-instance 'trail
                   :name (name tr)
                   :x-size (x-size tr)
                   :y-size (y-size tr)
                   :space (copy-array (space tr))
                   :num-of-op (num-of-op tr)
                   :num-of-food (num-of-food tr)
                   )))
      new-tr
    )
   )

(defparameter *food* '((0 1) (0 2) (0 3) (1 3) (2 3) (2 25) (2 26) (2 27) 
                       (3 3) (3 24) (3 29) (3 24) (3 29) (4 3) (4 24) (4 29)
                       (5 3)  (5 4) (5 5) (5 6) (5 8) (5 9) (5 10) (5 11) (5 12) (5 21) 
                       (5 22) (5 12) (6 12) (6 29) (7 20) (7 12) (8 12) 
                       (8 20) (9 12) (9 20) (9 29) (10 20) (11 12) (12 12)
                       (12 29) (13 12) (13 20) (14 12) (14 20) (14 26) 
                       (14 27) (14 28) (15 17) (15 23) (17 12) (18 12) 
                       (18 16) (18 24) (19 12) (19 16) (19 27) (20 12) 
                       (20 16) (21 12) (21 16) (22 12) (22 26) (23 12) 
                       (23 23) (24 3) (24 4) (24 7) (24 8) (24 9) (24 10) 
                       (24 11) (24 16) (25 1) (25 16) (26 1) (26 16) (27 1) 
                       (27 8) (27 9) (27 10) (27 11) (27 12) (27 13) (27 14) 
                       (28 1) (28 7) (29 7) (30 2) (30 3) (30 4) (30 5)))

(defparameter *santa-fe-trail* (make-instance 'trail
                                 :x-position-of-ant 0
                                 :y-position-of-ant 0
                                 :course-of-ant 0
                                 :name "santa-fe-trail"
                                 :x-size 32
                                 :y-size 32
                                 :space nil
                                 :num-of-op 400
                                 :num-of-food 89))

(setf (space *santa-fe-trail*)                                  
      (let 
           ((temp (make-array (list (x-size *santa-fe-trail*) (y-size *santa-fe-trail*)))))
         (dotimes (x (x-size *santa-fe-trail*))
            (dotimes (y (y-size *santa-fe-trail*))
               (if (mem-of-list (list x y) *food*)
                  (setf (aref temp y x) 1)
                  (setf (aref temp y x) 0)
                  )                                          
               )
            )
         temp)
      )


(defclass param ()
     (
      (size-pop
       :initform 500
       :initarg :size-pop
       :accessor size-pop)
      (num-of-gen
       :initform 51
       :initarg :num-of-gen
       :accessor num-of-gen)
      (max-in-depth
       :initform 6
       :initarg :max-in-depth
       :accessor max-in-depth)
      (max-creat-depth
       :initform 17
       :initarg :max-creat-depth
       :accessor max-creat-depth)
      (prob-of-crossover
       :initform 0.9
       :initarg :prob-of-crossover
       :accessor prob-of-crossover)
      (prob-of-reproduction
       :initform 0.1
       :initarg :prob-of-reproduction
       :accessor prob-of-reproduction)
      (prob-of-editation
       :initform 0.5
       :initarg :prob-of-editation
       :accessor prob-of-editation)
      (prop-of-decimation
       :initform 0.1
       :initarg :prop-of-decimation
       :accessor prop-of-decimation)
      (prob-of-chosse-intermediate-node
       :initform 0.9
       :initarg :prob-of-chosse-intermediate-node
       :accessor prob-of-chosse-intermediate-node)
      (prob-of-chosse-lamelar-node
       :initform 0.1
       :initarg :prob-of-chosse-lamelar-node
       :accessor prob-of-chosse-lamelar-node)
      (func-set
       :initform (list 
                   (make-instance 'func-node
                     :name 'if-food-ahead
                     :num-of-args 2)
                   (make-instance 'func-node
                     :name 'progn2
                     :num-of-args 2)
                   (make-instance 'func-node
                     :name 'progn3
                     :num-of-args 3)
                   )
       :initarg :func-set
       :accessor func-set)
      (term-set
        :initform (list 
                    (make-instance 'term-node
                      :name '(left))
                    (make-instance 'term-node
                     :name '(right))
                    (make-instance 'term-node
                      :name '(move))
                   )
        :initarg :term-set
        :accessor term-set)   
      (fitness-cases
        :initform (list *santa-fe-trail*)
        :initarg :fitness-cases           
        :accessor fitness-cases)                 
      )
   )

(defparameter *param* (make-instance 'param))
(defparameter *eaten-food* 0)
(defparameter *count* 0)
(defparameter *food-directly-in-front-of-ant-p* nil)
(defparameter *trail* nil)
(defparameter *graphic* 0)

